'' The dislin-8.4-header, i.e., dislin.h, was translated into dislinw.bi for FreeBASIC/Win9x by Hans L. Nemeschkal, October 2005.
'' Hans.Leo.Nemeschkal@univie.ac.at
'' Department of Theoretical Biologie, University of Vienna, Althanstrasse 14, A-1090 Vienna, Austria, European Union
''
'' including the libraries necessary for compilation
'' - for Windows 9x

'$inclib: "dislinfb"
'$inclib: "dismgc"
'' $inclib: "dismgc_d"
'$inclib: "user32"
'$inclib: "gdi32"



''
''
'' Note that the calls of the dislin-routines from FreeBASIC are principally composed as
'' 'd' + the 'original name of the dislin-routine'. The prefix 'd' should mark the call as concerning dislin.
'' The parameter definitions of dislin-routines, however, remain unchanged (see the dislin documentation and compare the header files!)
''
'' For instance, the dislin-routine 'setfil' must be called from FreeBASIC as 'dsetfil'. The parameter definitions for the
'' call remain unchanged as (byval cfil as byte ptr) in FreeBASIC  whereas (char *cfil) in the original dislin C-code.
''
''

REM CIRCUMVENTION CALLS - libdislinfb.a
REM
REM To avoid conflicts with keywords of FreeBASIC, the following circumvention calls were integrated into the additional C-library
REM libdislinfb.a, C-source: dislinfb.c
REM ********** Linux **********
REM Note please ! You should copy the following files to the Freebasic directory  C:\Freebasic\lib ,
REM   (1) libdislinfb.a
REM   (2) copy dislnc-8.4.a libdislnc.a
REM
REM Furthermore, You should make a directory for the dislin-header with md C:\Freebasic\inc\dislin
REM and the copy the header-file dislinw.bi into that new subdirectory

declare sub dcolor   cdecl alias "dcolor" (byval col as byte ptr)
declare sub dcircle  cdecl alias "dcircle"(byval nx as integer, byval ny as integer, byval nr as integer)
declare sub derase   cdecl alias "derase" ( )
declare sub dfield   cdecl alias "dfield" (byval xray as single ptr, byval yray as single ptr, byval uray as single ptr, byval vray as single ptr, byval d_n as integer, byval ivec as integer)
declare sub dgetgrf  cdecl alias "getgrf" (byval d_a as single ptr, byval d_e as single ptr, byval org as single ptr, byval dstep as single ptr, byval cax as byte ptr)
declare sub dline    cdecl alias "dline" (byval nx as integer, byval ny as integer, byval nu as integer, byval nv as integer)
declare sub dname    cdecl alias "dname" (byval cstr as byte ptr, byval cax as byte ptr)
declare sub dpoint   cdecl alias "dpoint" (byval nx as integer, byval ny as integer, byval nb as integer, byval nh as integer, byval ncol as integer)
declare sub dreset   cdecl alias "dreset" (byval cname as byte ptr)
declare sub dwindow  cdecl alias "dwindow" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub dsymbol  cdecl alias "dsymbol" (byval nsym as integer, byval nx as integer, byval ny as integer)



REM IMMEDIATE CALLS - libdislnc.a
REM
REM immediate calls with FUNCTION POINTERS -

'' void  setcbk (void (*callbck) (float *x, float *y), char *copt);
'' void  surfcp (float (*zfun)(float x, float y, int i), float a1, float a2, float astp, float b1, float b2, float bstp);
'' void  surfun (float (*zfun)(float x, float y), int ixpts, float xdel, int iypts, float ydel);
'' void  swgcb  (int id, void (*callbck) (int i, int *ir), int *iray);
'' void  swgcbk (int id, void (*callbck) (int i));

declare sub dsetcbk cdecl alias "setcbk" (byval callback as sub(byval d_x as single ptr, byval d_y as single ptr), byval copt as byte ptr)
declare sub dsurfcp cdecl alias "surfcp" (byval zfun as function(byval d_x as single, byval d_y as single, byval d_i as integer) as single,byval a1 as single, byval a2 as single, byval astp as single, byval b1 as single, byval b2 as single,byval bstp as single)
declare sub dsurfun cdecl alias "surfun" (byval zfun as function(byval d_x as single, byval d_y as single) as single, byval ixpts as integer, byval xdel as single, byval iypts as integer, byval ydel as single)
declare sub dswgcb  cdecl alias "swgcb"  (byval d_id as integer, byval callback as sub(byval d_i as integer, byval ir as integer ptr), byval iray as integer ptr)
declare sub dswgcbk cdecl alias "swgcbk" (byval d_id as integer, byval callback as sub(byval d_i as integer))


REM immediate calls without FUNCTION POINTERS -


'' A
declare sub dabs3pt cdecl alias "abs3pt" (byval d_x as single, byval d_y as single, byval d_z as single, byval xp as single ptr, byval yp as single ptr)
declare sub daddlab cdecl alias "addlab" (byval cstr as byte ptr, byval d_v as single, byval itic as integer, byval cax as byte ptr)
declare sub dangle  cdecl alias "angle"  (byval ngrad as integer)
declare sub darcell cdecl alias "arcell" (byval nx as integer, byval ny as integer, byval na as integer, byval nbx as integer, byval d_a as single, byval b as single, byval d_t as single)
declare sub dareaf  cdecl alias "areaf"  (byval nxray as integer ptr, byval nyray as integer ptr, byval d_n as integer)
declare sub dautres cdecl alias "autres" (byval ixdim as integer, byval iydim as integer)
declare sub dax2grf cdecl alias "ax2grf" ( )
declare sub dax3len cdecl alias "ax3len" (byval nxl as integer, byval nyl as integer, byval nzl as integer)
declare sub daxclrs cdecl alias "axclrs" (byval nclr as integer, byval copt as byte ptr, byval cax as byte ptr)
declare sub daxends cdecl alias "axends" (byval cstr as byte ptr, byval cax as byte ptr)
declare sub daxgit  cdecl alias "axgit"  ( )
declare sub daxis3d cdecl alias "axis3d" (byval x3 as single, byval y3 as single, byval z3 as single)
declare sub daxsbgd cdecl alias "axsbgd" (byval nclr as integer)
declare sub daxslen cdecl alias "axslen" (byval nxl as integer, byval nyl as integer)
declare sub daxsorg cdecl alias "axsorg" (byval nxa as integer, byval nya as integer)
declare sub daxspos cdecl alias "axspos" (byval nxa as integer, byval nya as integer)
declare sub daxsscl cdecl alias "axsscl" (byval cscl as byte ptr, byval cax as byte ptr)
declare sub daxstyp cdecl alias "axstyp" (byval copt as byte ptr)

'' B
declare sub dbarbor cdecl alias "barbor" (byval iclr as integer)
declare sub dbarclr cdecl alias "barclr" (byval ic1 as integer,byval ic2 as integer, byval ic3 as integer)
declare sub dbargrp cdecl alias "bargrp" (byval ngrp as integer, byval gap as single)
declare sub dbarmod cdecl alias "barmod" (byval cmod as byte ptr, byval copt as byte ptr)
declare sub dbaropt cdecl alias "baropt" (byval xf as single, byval d_a as single)
declare sub dbarpos cdecl alias "barpos" (byval copt as byte ptr)
declare sub dbars   cdecl alias "bars"   (byval xray as single ptr, byval y1ray as single ptr, byval y2ray as single ptr, byval d_n as integer)
declare sub dbars3d cdecl alias "bars3d" (byval xray as single ptr, byval yray as single ptr, byval z1ray as single ptr, byval z2ray as single ptr, byval xwray as single ptr, byval ywray as single ptr, byval icray as integer ptr, byval d_n as integer)
declare sub dbartyp cdecl alias "bartyp" (byval ctyp as byte ptr)
declare sub dbarwth cdecl alias "barwth" (byval factor as single)
declare sub dbasalf cdecl alias "basalf" (byval calph as byte ptr)
declare sub dbasdat cdecl alias "basdat" (byval d_id as integer, byval d_im as integer, byval d_iy as integer)
declare sub dbezier cdecl alias "bezier" (byval xray as single ptr, byval yray as single ptr, byval nray as integer, byval d_x as single ptr, byval d_y as single ptr, byval d_n as integer)
declare function dbitsi2 cdecl alias "bitsi2" (byval nbits as integer, byval mher as short, byval iher as integer, byval mhin as short, byval ihin as integer) as short
declare function dbitsi4 cdecl alias "bitsi4" (byval nbits as integer, byval mher as integer,byval iher as integer, byval mhin as integer, byval ihin as integer) as integer
declare sub dbmpfnt cdecl alias "bmpfnt" (byval copt as byte ptr)
declare sub dbox2d  cdecl alias "box2d"  ( )
declare sub dbox3d  cdecl alias "box3d"  ( )

''  C
declare sub dcenter cdecl alias "center" ( )
declare sub dcgmbgd cdecl alias "cgmbgd" (byval xr as single, byval xg as single, byval xb as single)
declare sub dcgmpic cdecl alias "cgmpic" (byval cstr as byte ptr)
declare sub dcgmver cdecl alias "cgmver" (byval nclr as integer)
declare sub dchaang cdecl alias "chaang" (byval angle as single)
declare sub dchacod cdecl alias "chacod" (byval copt as byte ptr)
declare sub dchaspc cdecl alias "chaspc" (byval xspc as single)
declare sub dchawth cdecl alias "chawth" (byval xwth as single)
declare sub dchnatt cdecl alias "chnatt" ( )
declare sub dchncrv cdecl alias "chncrv" (byval copt as byte ptr)
declare sub dchndot cdecl alias "chndot" ( )
declare sub dchndsh cdecl alias "chndsh" ( )
declare sub dchnbar cdecl alias "chnbar" (byval copt as byte ptr)
declare sub dchnpie cdecl alias "chnpie" (byval copt as byte ptr)
declare sub dcirc3p cdecl alias "circ3p" (byval x1 as single, byval y1 as single, byval x2 as single, byval y2 as single, byval x3 as single, byval y3 as single, byval xm as single ptr, byval ym as single ptr, byval d_r as single ptr)
declare sub dcircsp cdecl alias "circsp" (byval nspc as integer)
declare sub dclip3d cdecl alias "clip3d" (byval ctyp as byte ptr)
declare function dclosfl cdecl alias "closfl" (byval nu as integer) as integer
declare sub dclpbor cdecl alias "clpbor" (byval copt as byte ptr)
declare sub dclpmod cdecl alias "clpmod" (byval copt as byte ptr)
declare sub dclpwin cdecl alias "clpwin" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub dclrcyc cdecl alias "clrcyc" (byval index as integer, byval iclr as integer)
declare sub dclrmod cdecl alias "clrmod" (byval cmode as byte ptr)
declare sub dclswin cdecl alias "clswin" (byval d_id as integer)
declare sub dcolran cdecl alias "colran" (byval nca as integer, byval nce as integer)
declare sub dcolray cdecl alias "colray" (byval zray as single ptr, byval nray as integer ptr, byval d_n as integer)
declare sub dcomplx cdecl alias "complx" ( )
declare sub dconclr cdecl alias "conclr" (byval nray as integer ptr, byval d_n as integer)
declare sub dconcrv cdecl alias "concrv" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer, byval zlev as single)
declare sub dconfll cdecl alias "confll" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer, byval i1ray as integer ptr, byval i2ray as integer ptr, byval i3ray as integer ptr, byval ntri as integer, byval zlev as single ptr, byval nlev as integer)
declare sub dcongap cdecl alias "congap" (byval xfac as single)
declare sub dconlab cdecl alias "conlab" (byval clab as byte ptr)
declare sub dconmat cdecl alias "conmat" (byval zmat as single ptr, byval d_n as integer, byval d_m as integer, byval zlev as single)
declare sub dconmod cdecl alias "conmod" (byval xfac as single, byval xquot as single)
declare sub dconn3d cdecl alias "conn3d" (byval d_x as single, byval d_y as single, byval d_z as single)
declare sub dconnpt cdecl alias "connpt" (byval d_x as single, byval d_y as single)
declare sub dconpts cdecl alias "conpts" (byval xray as single ptr, byval d_n as integer, byval yray as single ptr, byval d_m as integer, byval zmat as single ptr, byval zlev as single, byval xpts as single ptr, byval ypts as single ptr, byval maxpts as integer, byval nray as integer ptr, byval maxray as integer, byval nlins as integer ptr)
declare sub dconshd cdecl alias "conshd" (byval xray as single ptr, byval d_n as integer, byval yray as single ptr, byval d_m as integer, byval zmat as single ptr, byval zlev as single ptr, byval nlev as integer)
declare sub dcontri cdecl alias "contri" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer, byval i1ray as integer ptr, byval i2ray as integer ptr, byval i3ray as integer ptr, byval ntri as integer, byval zlev as single)
declare sub dcontur cdecl alias "contur" (byval xray as single ptr, byval d_n as integer, byval yray as single ptr, byval d_m as integer, byval zmat as single ptr, byval zlev as single)
declare sub dcross  cdecl alias "cross"  ( )
declare sub dcrvmat cdecl alias "crvmat" (byval zmat as single ptr, byval d_n as integer, byval d_m as integer, byval ixpts as integer, byval iypts as integer)
declare sub dcrvtri cdecl alias "crvtri" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer, byval i1ray as integer ptr, byval i2ray as integer ptr, byval i3ray as integer ptr, byval ntri as integer)
declare sub dcsrmod cdecl alias "csrmod" (byval cmod as byte ptr, byval ckey as byte ptr)
declare function dcsrpos cdecl alias "csrpos" (byval d_ix as integer ptr, byval d_iy as integer ptr) as integer
declare sub dcsrpt1 cdecl alias "csrpt1" (byval d_ix as integer ptr, byval d_iy as integer ptr)
declare sub dcsrpts cdecl alias "csrpts" (byval d_ix as integer ptr, byval d_iy as integer ptr, byval nmax as integer, byval d_n as integer ptr, byval iret as integer ptr)
declare sub dcsrmov cdecl alias "csrmov" (byval d_ix as integer ptr, byval d_iy as integer ptr, byval nmax as integer, byval d_n as integer ptr, byval iret as integer ptr)
declare sub dcsrtyp cdecl alias "csrtyp" (byval copt as byte ptr)
declare sub dcsruni cdecl alias "csruni" (byval copt as byte ptr)
declare sub dcurv3d cdecl alias "curv3d" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer)
declare sub dcurve  cdecl alias "curve"  (byval xray as single ptr, byval yray as single ptr, byval d_n as integer)
declare sub dcurve3 cdecl alias "curve3" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer)
declare sub dcurvmp cdecl alias "curvmp" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer)
declare sub dcurvx3 cdecl alias "curvx3" (byval xray as single ptr, byval d_y as single, byval zray as single ptr, byval d_n as integer)
declare sub dcurvy3 cdecl alias "curvy3" (byval d_x as single, byval yray as single ptr, byval zray as single ptr, byval d_n as integer)

'' D
declare sub ddash   cdecl alias "dash"   ( )
declare sub ddashl  cdecl alias "dashl"  ( )
declare sub ddashm  cdecl alias "dashm"  ( )
declare sub ddattim cdecl alias "dattim" (byval cdate as byte ptr, byval ctime as byte ptr)
declare sub ddigits cdecl alias "digits" (byval ndig as integer, byval cax as byte ptr)
declare sub ddisfin cdecl alias "disfin" ( )
declare sub ddisini cdecl alias "disini" ( )
declare sub ddisalf cdecl alias "disalf" ( )
declare sub ddot    cdecl alias "dot"    ( )
declare sub ddotl   cdecl alias "dotl"   ( )
declare sub dduplx  cdecl alias "duplx"  ( )
declare function ddwgbut cdecl alias "dwgbut" (byval cstr as byte ptr, byval ival as integer) as integer

declare function ddwgfil cdecl alias "dwgfil" (byval clab as byte ptr, byval cstr as byte ptr, byval cmask as byte ptr) as zstring ptr
declare function ddwglis cdecl alias "dwglis" (byval clab as byte ptr, byval clis as byte ptr, byval ilis as integer) as integer
declare sub ddwgmsg cdecl alias "dwgmsg" (byval cstr as byte ptr)
declare function ddwgtxt cdecl alias "dwgtxt" (byval clab as byte ptr, byval cstr as byte ptr) as zstring ptr

''E
declare sub dellips cdecl alias "ellips" (byval nx as integer, byval ny as integer, byval na as integer, byval nb as integer)
declare sub dendgrf cdecl alias "endgrf" ( )
declare sub derrbar cdecl alias "errbar" (byval d_x as single ptr, byval d_y as single ptr, byval err1 as single ptr, byval err2 as single ptr, byval d_n as integer)
declare sub derrdev cdecl alias "errdev" (byval cdev as byte ptr)
declare sub derrfil cdecl alias "errfil" (byval cfil as byte ptr)
declare sub derrmod cdecl alias "errmod" (byval cstr as byte ptr, byval copt as byte ptr)
declare sub deushft cdecl alias "eushft" (byval cnat as byte ptr, byval cshf as byte ptr)
declare sub dexpzlb cdecl alias "expzlb" (byval cstr as byte ptr)

''F
declare function dfcha cdecl alias   "fcha" (byval d_x as single, byval ndig as integer, byval cstr as byte ptr) as integer
declare sub dfilbox cdecl alias "filbox" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub dfilclr cdecl alias "filclr" (byval copt as byte ptr)
declare sub dfilmod cdecl alias "filmod" (byval cmod as byte ptr)
declare sub dfixspc cdecl alias "fixspc" (byval xfac as single)
declare sub dflab3d cdecl alias "flab3d" ( )
declare function dflen cdecl alias   "flen" (byval d_x as single, byval ndig as integer) as integer
declare sub dframe  cdecl alias "frame"  (byval nfrm as integer)
declare sub dfrmclr cdecl alias "frmclr" (byval nclr as integer)
declare sub dfrmess cdecl alias "frmess" (byval nfrm as integer)

''G
declare sub dgapcrv cdecl alias "gapcrv" (byval xgap as single)
declare function dgetalf cdecl alias "getalf" ( ) as zstring ptr
declare function dgetang cdecl alias "getang" ( ) as integer
declare function dgetbpp cdecl alias "getbpp" ( ) as integer
declare sub dgetclp cdecl alias "getclp" (byval nx as integer ptr, byval ny as integer ptr, byval nw as integer ptr, byval nh as integer ptr)
declare function dgetclr cdecl alias "getclr" ( ) as integer
declare sub dgetdig cdecl alias "getdig" (byval nxdig as integer ptr, byval nydig as integer ptr, byval nzdig as integer ptr)
declare function dgetdsp cdecl alias "getdsp" ( ) as zstring ptr
declare function dgetfil cdecl alias "getfil" ( ) as zstring ptr
declare function dgethgt cdecl alias "gethgt" ( ) as integer
declare function dgethnm cdecl alias "gethnm" ( ) as integer
declare sub dgetind cdecl alias "getind" (byval index as integer, byval xr as single ptr, byval xg as single ptr, byval xb as single ptr)
declare sub dgetlab cdecl alias "getlab" (byval cx as byte ptr, byval cy as byte ptr, byval cz as byte ptr)
declare sub dgetlen cdecl alias "getlen" (byval nxl as integer ptr, byval nyl as integer ptr, byval nzl as integer ptr)
declare function dgetlev cdecl alias "getlev" ( ) as integer
declare function dgetlin cdecl alias "getlin" ( ) as integer
declare function dgetlit cdecl alias "getlit" (byval xp as single, byval yp as single, byval zp as single, byval xn as single, byval yn as single, byval zn as single) as integer
declare sub dgetmat cdecl alias "getmat" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer, byval zmat as single ptr, byval nx as integer, byval ny as integer, byval zval as single, byval imat as integer ptr, byval wmat as single ptr)
declare function dgetmfl cdecl alias "getmfl" ( ) as zstring ptr
declare function dgetmix cdecl alias "getmix" (byval copt as byte ptr) as zstring ptr
declare sub dgetor  cdecl alias "getor"  (byval nx0 as integer ptr, byval ny0 as integer ptr)
declare sub dgetpag cdecl alias "getpag" (byval nxpag as integer ptr, byval nypag as integer ptr)
declare function dgetpat cdecl alias "getpat" ( ) as long
declare function dgetplv cdecl alias "getplv" ( ) as integer
declare sub dgetpos cdecl alias "getpos" (byval nxa as integer ptr, byval nya as integer ptr)
declare sub dgetran cdecl alias "getran" (byval nca as integer ptr, byval nce as integer ptr)
declare sub dgetres cdecl alias "getres" (byval npb as integer ptr, byval nph as integer ptr)
declare sub dgetrgb cdecl alias "getrgb" (byval xr as single ptr, byval xg as single ptr, byval xb as single ptr)
declare sub dgetscl cdecl alias "getscl" (byval nxscl as integer ptr, byval nyscl as integer ptr, byval nzscl as integer ptr)
declare sub dgetscr cdecl alias "getscr" (byval nwidth as integer ptr, byval nheight as integer ptr)
declare function dgetshf cdecl alias "getshf" (byval copt as byte ptr) as zstring ptr
declare sub dgetsp1 cdecl alias "getsp1" (byval nxdis as integer ptr, byval nydis as integer ptr, byval nzdis as integer ptr)
declare sub dgetsp2 cdecl alias "getsp2" (byval nxdis as integer ptr, byval nydis as integer ptr, byval nzdis as integer ptr)
declare sub dgetsym cdecl alias "getsym" (byval nxsym as integer ptr, byval nysym as integer ptr)
declare sub dgettcl cdecl alias "gettcl" (byval nmaj as integer ptr, byval nmin as integer ptr)
declare sub dgettic cdecl alias "gettic" (byval nxtic as integer ptr, byval nytic as integer ptr, byval nztic as integer ptr)
declare function dgettyp cdecl alias "gettyp" ( ) as integer
declare function dgetuni cdecl alias "getuni" ( ) as any ptr
declare function dgetver cdecl alias "getver" ( ) as single
declare sub dgetvk  cdecl alias "getvk" (byval nv as integer ptr, byval nvfx as integer ptr, byval nvfy as integer ptr)
declare function dgetvlt cdecl alias "getvlt" ( ) as zstring ptr
declare function dgetwid cdecl alias "getwid" ( ) as integer
declare sub dgetwin cdecl alias "getwin" (byval d_ix as integer ptr, byval d_iy as integer ptr, byval nwidth as integer ptr, byval nheight as integer ptr)
declare function dgetxid cdecl alias "getxid" (byval copt as byte ptr) as integer
declare sub dgifmod cdecl alias "gifmod" (byval cmod as byte ptr, byval ckey as byte ptr)
declare function dgmxalf cdecl alias "gmxalf" (byval copt as byte ptr, byval ca as byte ptr, byval cb as byte ptr) as integer
declare sub dgothic cdecl alias "gothic" ( )
declare sub dgrace  cdecl alias "grace"  (byval ngrace as integer)
declare sub dgraf   cdecl alias "graf"   (byval xa as single, byval xe as single, byval xorg as single, byval xstp as single, byval ya as single, byval ye as single, byval yorg as single, byval ystp as single)
declare sub dgraf3  cdecl alias "graf3"  (byval xa as single, byval xe as single, byval xorg as single, byval xstp as single, byval ya as single, byval ye as single, byval yorg as single, byval ystp as single, byval za as single, byval ze as single, byval zorg as single, byval zstp as single)
declare sub dgraf3d cdecl alias "graf3d" (byval xa as single, byval xe as single, byval xorg as single, byval xstp as single, byval ya as single, byval ye as single, byval yorg as single, byval ystp as single, byval za as single, byval ze as single, byval zorg as single, byval zstp as single)
declare sub dgrafmp cdecl alias "grafmp" (byval xa as single, byval xe as single, byval xorg as single, byval xstp as single, byval ya as single, byval ye as single, byval yorg as single, byval ystp as single)
declare sub dgrdpol cdecl alias "grdpol" (byval ixgrid as integer, byval iygrid as integer)
declare sub dgrffin cdecl alias "grffin" ( )
declare sub dgrfini cdecl alias "grfini" (byval x1 as single, byval y1 as single, byval z1 as single, byval x2 as single, byval y2 as single, byval z2 as single, byval x3 as single, byval y3 as single, byval z3 as single)
declare sub dgrid cdecl alias "grid" (byval ixgrid as integer, byval iygrid as integer)
declare sub dgrid3d cdecl alias "grid3d" (byval ixgrid as integer, byval iygrid as integer, byval copt as byte ptr)
declare sub dgridmp cdecl alias "gridmp" (byval ixgrid as integer, byval iygrid as integer)
declare function dgwgatt cdecl alias "gwgatt" (byval d_id as integer, byval copt as byte ptr) as integer
declare function dgwgbox cdecl alias "gwgbox" (byval d_id as integer) as integer
declare function dgwgbut cdecl alias "gwgbut" (byval d_id as integer) as integer
declare sub dgwgfil cdecl alias "gwgfil" (byval d_id as integer, byval cfile as byte ptr)
declare function dgwglis cdecl alias "gwglis" (byval d_id as integer) as integer
declare function dgwgscl cdecl alias "gwgscl" (byval d_id as integer) as single
declare sub dgwgtxt cdecl alias "gwgtxt" (byval d_id as integer, byval ctext as byte ptr)
declare function dgwgxid cdecl alias "gwgxid" (byval d_id as integer) as integer

''H
declare sub dheight cdecl alias "height" (byval nhchar as integer)
declare sub dhelve  cdecl alias "helve"  ( )
declare sub dhelves cdecl alias "helves" ( )
declare sub dhistog cdecl alias "histog" (byval xray as single ptr, byval d_n as integer, byval d_x as single ptr, byval d_y as single ptr, byval d_m as integer ptr)
declare sub dhname  cdecl alias "hname"  (byval nhchar as integer)
declare sub dhsvrgb cdecl alias "hsvrgb" (byval xh as single, byval xs as single, byval xv as single, byval xr as single ptr, byval xg as single ptr, byval xb as single ptr)
declare sub dhsymbl cdecl alias "hsymbl" (byval nhsym as integer)
declare sub dhtitle cdecl alias "htitle" (byval nhtit as integer)
declare sub dhwfont cdecl alias "hwfont" ( )
declare sub dhworig cdecl alias "hworig" (byval nx as integer, byval ny as integer)
declare sub dhwpage cdecl alias "hwpage" (byval nw as integer, byval nh as integer)

''I
declare sub dimgbox cdecl alias "imgbox" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub dimgfin cdecl alias "imgfin" ( )
declare sub dimgfmt cdecl alias "imgfmt" (byval copt as byte ptr)
declare sub dimgini cdecl alias "imgini" ( )
declare sub dimgmod cdecl alias "imgmod" (byval copt as byte ptr)
declare sub dimgsiz cdecl alias "imgsiz" (byval nw as integer, byval nh as integer)
declare sub dinccrv cdecl alias "inccrv" (byval ncrv as integer)
declare function dincdat cdecl alias "incdat" (byval d_id as integer, byval d_im as integer, byval d_iy as integer) as integer
declare sub dincfil cdecl alias "incfil" (byval cfil as byte ptr)
declare sub dincmrk cdecl alias "incmrk" (byval nmrk as integer)
declare function dindrgb cdecl alias "indrgb" (byval xr as single, byval xg as single, byval xb as single) as integer
declare sub dintax  cdecl alias "intax"  ( )
declare function dintcha cdecl alias "intcha" (byval nx as integer, byval cstr as byte ptr) as integer
declare function dintlen cdecl alias "intlen" (byval nx as integer) as integer
declare sub ditmcat cdecl alias "itmcat" (byval clis as byte ptr, byval cstr as byte ptr)
declare function ditmcnt cdecl alias "itmcnt" (byval clis as byte ptr) as integer
declare function ditmstr cdecl alias "itmstr" (byval clis as byte ptr, byval nlis as integer) as zstring ptr

''L
declare sub dlabclr cdecl alias "labclr" (byval iclr as integer, byval copt as byte ptr)
declare sub dlabdig cdecl alias "labdig" (byval ndig as integer, byval cax as byte ptr)
declare sub dlabdis cdecl alias "labdis" (byval ndis as integer, byval cax as byte ptr)
declare sub dlabels cdecl alias "labels" (byval clab as byte ptr, byval cax as byte ptr)
declare sub dlabjus cdecl alias "labjus" (byval copt as byte ptr, byval cax as byte ptr)
declare sub dlabl3d cdecl alias "labl3d" (byval copt as byte ptr)
declare sub dlabmod cdecl alias "labmod" (byval ckey as byte ptr, byval cval as byte ptr, byval cax as byte ptr)
declare sub dlabpos cdecl alias "labpos" (byval cpos as byte ptr, byval cax as byte ptr)
declare sub dlabtyp cdecl alias "labtyp" (byval ctyp as byte ptr, byval cax as byte ptr)
declare sub dlegclr cdecl alias "legclr" ( )
declare sub dlegend cdecl alias "legend" (byval cbuf as byte ptr, byval ncor as integer)
declare sub dlegini cdecl alias "legini" (byval cbuf as byte ptr, byval nlin as integer, byval nmaxln as integer)
declare sub dleglin cdecl alias "leglin" (byval cbuf as byte ptr, byval cstr as byte ptr, byval ilin as integer)
declare sub dlegopt cdecl alias "legopt" (byval x1 as single, byval x2 as single, byval x3 as single)
declare sub dlegpat cdecl alias "legpat" (byval ityp as integer, byval ithk as integer, byval isym as integer, byval ipat as long, byval iclr as integer, byval ilin as integer)
declare sub dlegpos cdecl alias "legpos" (byval nx as integer, byval ny as integer)
declare sub dlegtit cdecl alias "legtit" (byval cstr as byte ptr)
declare sub dlfttit cdecl alias "lfttit" ( )
declare sub dlight  cdecl alias "light"  (byval copt as byte ptr)
declare sub dlincyc cdecl alias "lincyc" (byval index as integer, byval ityp as integer)
declare sub dlinesp cdecl alias "linesp" (byval xfac as single)
declare sub dlintyp cdecl alias "lintyp" (byval ntyp as integer)
declare sub dlinwid cdecl alias "linwid" (byval d_i as integer)
declare sub dlitmod cdecl alias "litmod" (byval d_id as integer, byval copt as byte ptr)
declare sub dlitopt cdecl alias "litopt" (byval d_id as integer, byval xval as single, byval copt as byte ptr)
declare sub dlitpos cdecl alias "litpos" (byval d_id as integer, byval d_x as single, byval d_y as single, byval d_z as single, byval copt as byte ptr)
declare sub dlncap  cdecl alias "lncap"  (byval copt as byte ptr)
declare sub dlnjoin cdecl alias "lnjoin" (byval copt as byte ptr)
declare sub dlnmlt  cdecl alias "lnmlt"  (byval d_x as single)
declare sub dlogtic cdecl alias "logtic" (byval cmod as byte ptr)
declare sub dlsechk cdecl alias "lsechk" (byval cmod as byte ptr)

''M
declare sub dmapbas cdecl alias "mapbas" (byval cmod as byte ptr)
declare sub dmapfil cdecl alias "mapfil" (byval cfil as byte ptr, byval copt as byte ptr)
declare sub dmaplev cdecl alias "maplev" (byval cmod as byte ptr)
declare sub dmapmod cdecl alias "mapmod" (byval cmod as byte ptr)
declare sub dmappol cdecl alias "mappol" (byval xpol as single, byval ypol as single)
declare sub dmapref cdecl alias "mapref" (byval ylower as single, byval yupper as single)
declare sub dmapsph cdecl alias "mapsph" (byval xrad as single)
declare sub dmarker cdecl alias "marker" (byval nsym as integer)
declare sub dmatopt cdecl alias "matopt" (byval xval as single, byval copt as byte ptr)
declare sub dmdfmat cdecl alias "mdfmat" (byval nx as integer, byval ny as integer, byval weight as single)
declare sub dmessag cdecl alias "messag" (byval cstr as byte ptr, byval nx as integer, byval ny as integer)
declare sub dmetafl cdecl alias "metafl" (byval cstr as byte ptr)
declare sub dmixalf cdecl alias "mixalf" ( )
declare sub dmixleg cdecl alias "mixleg" ( )
declare function dmoment cdecl alias "moment" (byval xray as single ptr, byval d_n as integer, byval copt as byte ptr) as single
declare sub dmpaepl cdecl alias "mpaepl" (byval d_i as integer)
declare sub dmplang cdecl alias "mplang" (byval d_x as single)
declare sub dmplclr cdecl alias "mplclr" (byval nbg as integer, byval nfg as integer)
declare sub dmplpos cdecl alias "mplpos" (byval nx as integer, byval ny as integer)
declare sub dmplsiz cdecl alias "mplsiz" (byval nsize as integer)
declare sub dmpslogo cdecl alias "mpslogo" (byval nx as integer, byval ny as integer, byval nsize as integer, byval copt as byte ptr)
declare sub dmsgbox cdecl alias "msgbox" (byval cstr as byte ptr)
declare sub dmshclr cdecl alias "mshclr" (byval d_ic as integer)
declare sub dmylab  cdecl alias "mylab"  (byval cstr as byte ptr, byval itick as integer, byval cax as byte ptr)
declare sub dmyline cdecl alias "myline" (byval nray as integer ptr, byval d_n as integer)
declare sub dmypat  cdecl alias "mypat"  (byval iang as integer, byval itype as integer, byval idens as integer, byval icross as integer)
declare sub dmysymb cdecl alias "mysymb" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer, byval isym as integer, byval iflag as integer)
declare sub dmyvlt cdecl alias "myvlt"   (byval xr as single ptr, byval xg as single ptr, byval xb as single ptr, byval d_n as integer)

''N
declare sub dnamdis cdecl alias "namdis" (byval ndis as integer, byval cax as byte ptr)
declare sub dnamjus cdecl alias "namjus" (byval copt as byte ptr, byval cax as byte ptr)
declare sub dneglog cdecl alias "neglog" (byval eps as single)
declare sub dnewmix cdecl alias "newmix" ( )
declare sub dnewpag cdecl alias "newpag" ( )
declare function dnlmess cdecl alias "nlmess" (byval cstr as byte ptr) as integer
declare function dnlnumb cdecl alias "nlnumb" (byval d_x as single, byval ndig as integer) as integer
declare sub dnoarln cdecl alias "noarln" ( )
declare sub dnobar  cdecl alias "nobar"  ( )
declare sub dnobgd  cdecl alias "nobgd"  ( )
declare sub dnochek cdecl alias "nochek" ( )
declare sub dnoclip cdecl alias "noclip" ( )
declare sub dnofill cdecl alias "nofill" ( )
declare sub dnograf cdecl alias "nograf" ( )
declare sub dnohide cdecl alias "nohide" ( )
declare sub dnoline cdecl alias "noline" (byval cax as byte ptr)
declare sub dnumber cdecl alias "number" (byval d_x as single, byval ndig as integer, byval nx as integer, byval ny as integer)
declare sub dnumfmt cdecl alias "numfmt" (byval copt as byte ptr)
declare sub dnumode cdecl alias "numode" (byval cdec as byte ptr, byval cgrp as byte ptr, byval cpos as byte ptr, byval cfix as byte ptr)
declare function dnwkday cdecl alias "nwkday" (byval d_id as integer, byval d_im as integer, byval d_iy as integer) as integer
declare function dnxlegn cdecl alias "nxlegn" (byval cbuf as byte ptr) as integer
declare function dnxposn cdecl alias "nxposn" (byval d_x as single) as integer
declare function dnylegn cdecl alias "nylegn" (byval cbuf as byte ptr) as integer
declare function dnyposn cdecl alias "nyposn" (byval d_y as single) as integer
declare function dnzposn cdecl alias "nzposn" (byval d_z as single) as integer

''O
declare function dopenfl cdecl alias "openfl" (byval cfil as byte ptr, byval nu as integer, byval irw as integer) as integer 
declare sub dopnwin cdecl alias "opnwin" (byval d_id as integer)
declare sub dorigin cdecl alias "origin" (byval nx0 as integer, byval ny0 as integer)

''P
declare sub dpage   cdecl alias "page"   (byval nw as integer, byval nh as integer)
declare sub dpagera cdecl alias "pagera" ( )
declare sub dpagfll cdecl alias "pagfll" (byval nclr as integer)
declare sub dpaghdr cdecl alias "paghdr" (byval cstr1 as byte ptr, byval cstr2 as byte ptr, byval iopt as integer, byval idir as integer)
declare sub dpagmod cdecl alias "pagmod" (byval cmod as byte ptr)
declare sub dpagorg cdecl alias "pagorg" (byval cpos as byte ptr)
declare sub dpatcyc cdecl alias "patcyc" (byval index as integer, byval ipat as long)
declare function dpdfbuf cdecl alias "pdfbuf" (byval cbuf as byte ptr, byval nmax as integer) as integer
declare sub dpdfmod cdecl alias "pdfmod" (byval cmod as byte ptr, byval ckey as byte ptr)
declare sub dpdfmrk cdecl alias "pdfmrk" (byval cstr as byte ptr, byval copt as byte ptr)
declare sub dpenwid cdecl alias "penwid" (byval d_x as single)
declare sub dpie    cdecl alias "pie"    (byval nxm as integer, byval nym as integer, byval nr as integer, byval d_a as single, byval b as single)
declare sub dpiebor cdecl alias "piebor" (byval iclr as integer)
declare sub dpieclr cdecl alias "pieclr" (byval ic1 as integer ptr, byval ic2 as integer ptr, byval d_n as integer)
declare sub dpieexp cdecl alias "pieexp" ( )
declare sub dpiegrf cdecl alias "piegrf" (byval cbuf as byte ptr, byval nlin as integer, byval xray as single ptr, byval nseg as integer)
declare sub dpielab cdecl alias "pielab" (byval clab as byte ptr, byval cpos as byte ptr)
declare sub dpieopt cdecl alias "pieopt" (byval xf as single, byval d_a as single)
declare sub dpietyp cdecl alias "pietyp" (byval ctyp as byte ptr)
declare sub dpievec cdecl alias "pievec" (byval ivec as integer, byval copt as byte ptr)
declare sub dpngmod cdecl alias "pngmod" (byval cmod as byte ptr, byval ckey as byte ptr)
declare sub dpolar  cdecl alias "polar"  (byval xe as single, byval xorg as single, byval xstp as single, byval yorg as single, byval ystp as single)
declare sub dpolcrv cdecl alias "polcrv" (byval cpol as byte ptr)
declare sub dpolmod cdecl alias "polmod" (byval cpos as byte ptr, byval cdir as byte ptr)
declare sub dpos2pt cdecl alias "pos2pt" (byval d_x as single, byval d_y as single, byval xp as single ptr, byval yp as single ptr)
declare sub dpos3pt cdecl alias "pos3pt" (byval d_x as single, byval d_y as single, byval d_z as single, byval xp as single ptr, byval yp as single ptr, byval zp as single ptr)
declare function   dposifl cdecl alias "posifl" (byval nu as integer, byval nbyte as integer) as integer 
declare sub dprojct cdecl alias "projct" (byval cproj as byte ptr)
declare sub dpsfont cdecl alias "psfont" (byval cfont as byte ptr)

''Q
declare sub dqplot  cdecl alias "qplot"  (byval xray as single ptr, byval yray as single ptr, byval d_n as integer)
declare sub dqplsca cdecl alias "qplsca" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer)
declare sub dqplpie cdecl alias "qplpie" (byval xray as single ptr, byval d_n as integer)
declare sub dqplbar cdecl alias "qplbar" (byval yray as single ptr, byval d_n as integer)
declare sub dqplclr cdecl alias "qplclr" (byval zmat as single ptr, byval d_n as integer, byval d_m as integer)
declare sub dqplsur cdecl alias "qplsur" (byval zmat as single ptr, byval d_n as integer, byval d_m as integer)
declare sub dqplcon cdecl alias "qplcon" (byval zmat as single ptr, byval d_n as integer, byval d_m as integer, byval nlv as integer)

''R
declare function drbfpng cdecl alias "rbfpng" (byval cbuf as byte ptr, byval nmax as integer) as integer
declare sub drbmp cdecl alias "rbmp"     (byval cfil as byte ptr)
declare function dreadfl cdecl alias "readfl" (byval nu as integer, byval cbuf as ubyte ptr, byval nbyte as integer) as integer 
declare sub dreawgt cdecl alias "reawgt" ( )
declare sub drecfll cdecl alias "recfll" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer, byval ncol as integer)
declare sub drectan cdecl alias "rectan" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub drel3pt cdecl alias "rel3pt" (byval d_x as single, byval d_y as single, byval d_z as single, byval xp as single ptr, byval yp as single ptr)
declare sub dresatt cdecl alias "resatt" ( )
declare sub drevscr cdecl alias "revscr" ( )
declare sub drgbhsv cdecl alias "rgbhsv" (byval xr as single, byval xg as single, byval xb as single, byval xh as single ptr, byval xs as single ptr, byval xv as single ptr)
declare sub drgif   cdecl alias "rgif"   (byval cfil as byte ptr)
declare sub drgtlab cdecl alias "rgtlab" ( )
declare sub drimage cdecl alias "rimage" (byval cfil as byte ptr)
declare sub drlarc  cdecl alias "rlarc"  (byval xm as single, byval ym as single, byval xa as single, byval xb as single, byval d_a as single,  byval b as single,  byval d_t as single)
declare sub drlarea cdecl alias "rlarea" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer)
declare sub drlcirc cdecl alias "rlcirc" (byval xm as single, byval ym as single, byval d_r as single)
declare sub drlconn cdecl alias "rlconn" (byval d_x as single, byval d_y as single)
declare sub drlell  cdecl alias "rlell"  (byval xm as single, byval ym as single, byval d_a as single, byval b as single)
declare sub drline  cdecl alias "rline"  (byval d_x as single, byval d_y as single, byval d_u as single, byval d_v as single)
declare sub drlmess cdecl alias "rlmess" (byval cstr as byte ptr, byval d_x as single, byval d_y as single)
declare sub drlnumb cdecl alias "rlnumb" (byval d_x as single, byval ndig as integer, byval xp as single, byval yp as single)
declare sub drlpie  cdecl alias "rlpie"  (byval xm as single, byval ym as single, byval d_r as single, byval d_a as single, byval b as single)
declare sub drlpoin cdecl alias "rlpoin" (byval d_x as single, byval d_y as single, byval nb as integer, byval nh as integer, byval ncol as integer)
declare sub drlrec  cdecl alias "rlrec"  (byval d_x as single, byval d_y as single, byval xw as single, byval xh as single)
declare sub drlrnd  cdecl alias "rlrnd"  (byval d_x as single, byval d_y as single, byval xb as single, byval xh as single, byval irnd as integer)
declare sub drlsec  cdecl alias "rlsec"  (byval xm as single, byval ym as single, byval r1 as single, byval r2 as single, byval d_a as single, byval b as single, byval ncol as integer)
declare sub drlstrt cdecl alias "rlstrt" (byval d_x as single, byval d_y as single)
declare sub drlsymb cdecl alias "rlsymb" (byval nsym as integer, byval d_x as single, byval d_y as single)
declare sub drlvec  cdecl alias "rlvec"  (byval x1 as single, byval y1 as single, byval x2 as single, byval y2 as single, byval ivec as integer)
declare sub drlwind cdecl alias "rlwind" (byval xk as single, byval d_x as single, byval d_y as single, byval nwidth as integer, byval d_a as single)
declare sub drndrec cdecl alias "rndrec" (byval nx as integer, byval ny as integer, byval nb as integer, byval nh as integer, byval irnd as integer)
declare sub drpixel cdecl alias "rpixel" (byval d_ix as integer, byval d_iy as integer, byval iclr as integer ptr)
declare sub drpixls cdecl alias "rpixls" (byval iray as ubyte ptr, byval d_ix as integer, byval d_iy as integer, byval nw as integer, byval nh as integer)
declare sub drpng   cdecl alias "rpng"  (byval cfil as byte ptr)
declare sub drppm   cdecl alias "rppm"  (byval cfil as byte ptr)
declare sub drpxrow cdecl alias "rpxrow" (byval iray as ubyte ptr, byval d_ix as integer, byval d_iy as integer, byval d_n as integer)
declare sub drtiff  cdecl alias "rtiff" (byval cfil as byte ptr)
declare sub drvynam cdecl alias "rvynam" ( )

''S
declare sub  dscale  cdecl alias "scale"  (byval cscl as byte ptr, byval cax as byte ptr)
declare sub  dsclfac cdecl alias "sclfac" (byval xfac as single)
declare sub  dsclmod cdecl alias "sclmod" (byval cmode as byte ptr)
declare sub  dscrmod cdecl alias "scrmod" (byval cmode as byte ptr)
declare sub  dsector cdecl alias "sector" (byval nx as integer, byval ny as integer, byval nr1 as integer, byval nr2 as integer, byval d_a as single, byval b as single, byval ncol as integer)
declare sub  dselwin cdecl alias "selwin" (byval d_id as integer)
declare sub  dsendbf cdecl alias "sendbf" ( )
declare sub  dsendmb cdecl alias "sendmb" ( )
declare sub  dsendok cdecl alias "sendok" ( )
declare sub  dserif  cdecl alias "serif"  ( )
declare sub  dsetbas cdecl alias "setbas" (byval xfac as single)
declare sub  dsetclr cdecl alias "setclr" (byval ncol as integer)
declare sub  dsetcsr cdecl alias "setcsr" (byval copt as byte ptr)
declare sub  dsetexp cdecl alias "setexp" (byval fexp as single)
declare sub  dsetfil cdecl alias "setfil" (byval cfil as byte ptr)
declare sub  dsetgrf cdecl alias "setgrf" (byval c1 as byte ptr, byval c2 as byte ptr, byval c3 as byte ptr, byval c4 as byte ptr)
declare sub  dsetind cdecl alias "setind" (byval index as integer, byval xr as single, byval xg as single, byval xb as single)
declare sub  dsetmix cdecl alias "setmix" (byval cstr as byte ptr, byval cmix as byte ptr)
declare sub  dsetpag cdecl alias "setpag" (byval cpag as byte ptr)
declare sub  dsetres cdecl alias "setres" (byval npb as integer, byval nph as integer)
declare sub  dsetrgb cdecl alias "setrgb" (byval xr as single, byval xg as single, byval xb as single)
declare sub  dsetscl cdecl alias "setscl" (byval xray as single ptr, byval d_n as integer, byval cax as byte ptr)
declare sub  dsetvlt cdecl alias "setvlt" (byval cvlt as byte ptr)
declare sub  dsetxid cdecl alias "setxid" (byval d_id as integer, byval copt as byte ptr)
declare sub  dshdafr cdecl alias "shdafr" (byval inray as integer ptr, byval ipray as long ptr, byval icray as integer ptr, byval d_n as integer)
declare sub  dshdcha cdecl alias "shdcha" ( )
declare sub  dshdcrv cdecl alias "shdcrv" (byval x1ray as single ptr, byval y1ray as single ptr, byval n1 as integer, byval x2ray as single ptr, byval y2ray as single ptr, byval n2 as integer)
declare sub  dshdeur cdecl alias "shdeur" (byval inray as integer ptr, byval ipray as long ptr, byval icray as integer ptr, byval d_n as integer)
declare sub  dshdmap cdecl alias "shdmap" (byval cmap as byte ptr)
declare sub  dshdmod cdecl alias "shdmod" (byval copt as byte ptr, byval ctyp as byte ptr)
declare sub  dshdpat cdecl alias "shdpat" (byval ipat as long)
declare sub  dshdusa cdecl alias "shdusa" (byval inray as integer ptr, byval ipray as long ptr, byval icray as integer ptr, byval d_n as integer)
declare sub  dshield cdecl alias "shield" (byval carea as byte ptr, byval cmode as byte ptr)
declare sub  dshlcir cdecl alias "shlcir" (byval nx as integer, byval ny as integer, byval nr as integer)
declare sub  dshldel cdecl alias "shldel" (byval d_id as integer)
declare sub  dshlell cdecl alias "shlell" (byval nx as integer, byval ny as integer, byval na as integer, byval nb as integer, byval d_t as single)
declare function dshlind cdecl alias "shlind" ( ) as integer
declare sub  dshlpie cdecl alias "shlpie" (byval nx as integer, byval ny as integer, byval nr as integer, byval d_a as single, byval b as single)
declare sub  dshlpol cdecl alias "shlpol" (byval nxray as integer ptr, byval nyray as integer ptr, byval d_n as integer)
declare sub  dshlrct cdecl alias "shlrct" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer, byval d_t as single)
declare sub  dshlrec cdecl alias "shlrec" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub  dshlres cdecl alias "shlres" (byval d_n as integer)
declare sub  dshlsur cdecl alias "shlsur" ( )
declare sub  dshlvis cdecl alias "shlvis" (byval d_id as integer, byval cmode as byte ptr)
declare sub  dsimplx cdecl alias "simplx" ( )
declare function dskipfl cdecl alias "skipfl" (byval nu as integer, byval nbyte as integer) as integer 
declare sub  dsmxalf cdecl alias "smxalf" (byval calph as byte ptr, byval c1 as byte ptr, byval c2 as byte ptr, byval d_n as integer)
declare sub  dsolid  cdecl alias "solid"  ( )
declare sub  dsortr1 cdecl alias "sortr1" (byval xray as single ptr, byval d_n as integer, byval copt as byte ptr)
declare sub  dsortr2 cdecl alias "sortr2" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer, byval copt as byte ptr)
declare sub  dsphe3d cdecl alias "sphe3d" (byval xm as single, byval ym as single, byval zm as single, byval d_r as single, byval d_n as integer, byval d_m as integer)
declare sub  dspline cdecl alias "spline" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer, byval xsray as single ptr, byval ysray as single ptr, byval nspl as integer ptr)
declare sub  dsplmod cdecl alias "splmod" (byval ngrad as integer, byval npts as integer)
declare sub  dstrt3d cdecl alias "strt3d" (byval d_x as single, byval d_y as single, byval d_z as single)
declare sub  dstrtpt cdecl alias "strtpt" (byval d_x as single, byval d_y as single)
declare sub  dsurclr cdecl alias "surclr" (byval ictop as integer, byval icbot as integer)
declare sub  dsurfce cdecl alias "surfce" (byval xray as single ptr, byval d_n as integer, byval yray as single ptr, byval d_m as integer, byval zmat as single ptr)
declare sub  dsuriso cdecl alias "suriso" (byval xray as single ptr, byval nx as integer, byval yray as single ptr, byval ny as integer, byval zray as single ptr, byval nz as integer, byval wmat as single ptr, byval wlev as single)
declare sub  dsurmat cdecl alias "surmat" (byval zmat as single ptr, byval nx as integer, byval ny as integer, byval ixpts as integer, byval iypts as integer)
declare sub  dsurmsh cdecl alias "surmsh" (byval copt as byte ptr)
declare sub  dsuropt cdecl alias "suropt" (byval copt as byte ptr)
declare sub  dsurshd cdecl alias "surshd" (byval xray as single ptr, byval d_n as integer, byval yray as single ptr, byval d_m as integer, byval zmat as single ptr)
declare sub  dsursze cdecl alias "sursze" (byval xmin as single, byval xmax as single, byval ymin as single, byval ymax as single)
declare sub  dsurtri cdecl alias "surtri" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer, byval i1ray as integer ptr, byval i2ray as integer ptr, byval i3ray as integer ptr, byval ntri as integer)
declare sub  dsurvis cdecl alias "survis" (byval cvis as byte ptr)
declare sub  dswapi2 cdecl alias "swapi2" (byval iray as short ptr, byval d_n as integer)
declare sub  dswapi4 cdecl alias "swapi4" (byval iray as integer ptr, byval d_n as integer)
declare sub  dswgatt cdecl alias "swgatt" (byval d_id as integer, byval cval as byte ptr, byval copt as byte ptr)
declare sub  dswgbox cdecl alias "swgbox" (byval d_ip as integer, byval ival as integer)
declare sub  dswgbut cdecl alias "swgbut" (byval d_ip as integer, byval ival as integer)
declare sub  dswgclr cdecl alias "swgclr" (byval xr as single, byval xg as single, byval xb as single, byval copt as byte ptr)
declare sub  dswgdrw cdecl alias "swgdrw" (byval d_x as single)
declare sub  dswgfil cdecl alias "swgfil" (byval d_ip as integer, byval cval as byte ptr)
declare sub  dswgfnt cdecl alias "swgfnt" (byval cfnt as byte ptr, byval d_n as integer)
declare sub  dswgfoc cdecl alias "swgfoc" (byval d_id as integer)
declare sub  dswghlp cdecl alias "swghlp" (byval cstr as byte ptr)
declare sub  dswgjus cdecl alias "swgjus" (byval ctyp as byte ptr, byval cwidg as byte ptr)
declare sub  dswglis cdecl alias "swglis" (byval d_ip as integer, byval ival as integer)
declare sub  dswgmix cdecl alias "swgmix" (byval d_c as byte ptr, byval cstr as byte ptr)
declare sub  dswgmod cdecl alias "swgmod" (byval cmod as byte ptr)
declare sub  dswgmrg cdecl alias "swgmrg" (byval ival as integer, byval cstr as byte ptr)
declare sub  dswgoff cdecl alias "swgoff" (byval nx as integer, byval ny as integer)
declare sub  dswgopt cdecl alias "swgopt" (byval cval as byte ptr, byval copt as byte ptr)
declare sub  dswgpop cdecl alias "swgpop" (byval copt as byte ptr)
declare sub  dswgpos cdecl alias "swgpos" (byval nx as integer, byval ny as integer)
declare sub  dswgscl cdecl alias "swgscl" (byval d_ip as integer, byval xval as single)
declare sub  dswgsiz cdecl alias "swgsiz" (byval nx as integer, byval ny as integer)
declare sub  dswgspc cdecl alias "swgspc" (byval xw as single, byval xh as single)
'' declare sub  dswgstp cdecl alias "swgstp" (byval step as single) step = name conflict with freebasic command !
declare sub  dswgstp cdecl alias "swgstp" (byval dstep as single)
declare sub  dswgtit cdecl alias "swgtit" (byval ctit as byte ptr)
declare sub  dswgtxt cdecl alias "swgtxt" (byval d_ip as integer, byval cval as byte ptr)
declare sub  dswgtyp cdecl alias "swgtyp" (byval ctyp as byte ptr, byval cwidg as byte ptr)
declare sub  dswgwin cdecl alias "swgwin" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub  dswgwth cdecl alias "swgwth" (byval nchar as integer)
declare sub  dsymfil cdecl alias "symfil" (byval cdev as byte ptr, byval cstat as byte ptr)
declare sub  dsymrot cdecl alias "symrot" (byval angle as single)

''T
declare function dtellfl cdecl alias "tellfl" (byval nu as integer) as integer 
declare sub dtexmod cdecl alias "texmod" (byval copt as byte ptr)
declare sub dtexopt cdecl alias "texopt" (byval copt as byte ptr, byval ctyp as byte ptr)
declare sub dthkcrv cdecl alias "thkcrv" (byval nthk as integer)
declare sub dticks  cdecl alias "ticks"  (byval itick as integer, byval cax as byte ptr)
declare sub dticlen cdecl alias "ticlen" (byval nmaj as integer, byval nmin as integer)
declare sub dticmod cdecl alias "ticmod" (byval copt as byte ptr, byval cax as byte ptr)
declare sub dticpos cdecl alias "ticmod" (byval cpos as byte ptr, byval cax as byte ptr)
declare sub dtifmod cdecl alias "tifmod" (byval d_n as integer, byval cval as byte ptr, byval copt as byte ptr)
declare sub dtiforg cdecl alias "tiforg" (byval nx as integer, byval ny as integer)
declare sub dtifwin cdecl alias "tifwin" (byval nx as integer, byval ny as integer, byval nw as integer, byval nh as integer)
declare sub dtimopt cdecl alias "timopt" ( )
declare sub dtitjus cdecl alias "titjus" (byval copt as byte ptr)
declare sub dtitle  cdecl alias "title"  ( )
declare sub dtitlin cdecl alias "titlin" (byval cstr as byte ptr, byval d_n as integer)
declare sub dtitpos cdecl alias "titpos" (byval copt as byte ptr)
declare sub dtrfco1 cdecl alias "trfco1" (byval xray as single ptr, byval d_n as integer, byval cfrom as byte ptr, byval cto as byte ptr) 
declare sub dtrfco2 cdecl alias "trfco2" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer, byval cfrom as byte ptr, byval cto as byte ptr) 
declare sub dtrfco3 cdecl alias "trfco3" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer, byval cfrom as byte ptr, byval cto as byte ptr)
declare sub dtrfdat cdecl alias "trfdat" (byval ndays as integer, byval d_id as integer ptr, byval d_im as integer ptr, byval d_iy as integer ptr) 
declare sub dtrfmat cdecl alias "trfmat" (byval zmat as single ptr, byval nx as integer, byval ny as integer, byval zmat2 as single ptr, byval nx2 as integer, byval ny2 as integer)
declare sub dtrfrel cdecl alias "trfrel" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer)
declare sub dtrfres cdecl alias "trfres" ( )
declare sub dtrfrot cdecl alias "trfrot" (byval xang as single, byval nx as integer, byval ny as integer)
declare sub dtrfscl cdecl alias "trfscl" (byval xscl as single, byval yscl as single)
declare sub dtrfshf cdecl alias "trfshf" (byval nx as integer, byval ny as integer)
declare function dtriang cdecl alias "triang" (byval xray as single ptr, byval yray as single ptr, byval d_n as integer, byval i1ray as integer ptr, byval i2ray as integer ptr, byval i3ray as integer ptr, byval nmax as integer) as integer 
declare sub dtrifll cdecl alias "trifll" (byval xray as single ptr, byval yray as single ptr)
declare sub dtriplx cdecl alias "triplx" ( )
declare sub dtripts cdecl alias "tripts" (byval xray as single ptr, byval yray as single ptr, byval zray as single ptr, byval d_n as integer, byval i1ray as integer ptr, byval i2ray as integer ptr, byval i3ray as integer ptr, byval ntri as integer, byval zlev as single, byval xpts as single ptr, byval ypts as single ptr, byval maxpts as integer, byval nptray as integer ptr, byval maxray as integer, byval nlins as integer ptr)
declare function dtrmlen cdecl alias "trmlen" (byval cstr as byte ptr) as integer
declare sub dtxtjus cdecl alias "txtjus" (byval copt as byte ptr)

''U
declare sub dunit   cdecl alias "unit"  (byval d_fp as any ptr)
declare sub dunits  cdecl alias "units" (byval copt as byte ptr)
declare sub dupstr  cdecl alias "upstr" (byval cstr as byte ptr)

''V
declare sub dvang3d cdecl alias "vang3d" (byval d_a as single)
declare sub dvclp3d cdecl alias "vclp3d" (byval x1 as single, byval x2 as single)
declare sub dvector cdecl alias "vector" (byval nx1 as integer, byval ny1 as integer, byval nx2 as integer, byval ny2 as integer, byval ivec as integer)
declare sub dvectr3 cdecl alias "vectr3" (byval x1 as single, byval y1 as single, byval z1 as single, byval x2 as single, byval y2 as single, byval z2 as single, byval ivec as integer)
declare sub dvfoc3d cdecl alias "vfoc3d" (byval d_x as single, byval d_y as single, byval d_z as single, byval cview as byte ptr)
declare sub dview3d cdecl alias "view3d" (byval xvu as single, byval yvu as single, byval zvu as single, byval cvu as byte ptr)
declare sub dvkxbar cdecl alias "vkxbar" (byval nvfx as integer)
declare sub dvkybar cdecl alias "vkybar" (byval nvfy as integer)
declare sub dvkytit cdecl alias "vkytit" (byval nvfy as integer)
declare sub dvltfil cdecl alias "vltfil" (byval cfl as byte ptr, byval copt as byte ptr)
declare sub dvup3d  cdecl alias "vup3d"  (byval d_a as single)

''W
declare function dwgapp  cdecl alias "wgapp" (byval d_ip as integer, byval clab as byte ptr) as integer
declare function dwgbas  cdecl alias "wgbas" (byval d_ip as integer, byval ctyp as byte ptr) as integer
declare function dwgbox  cdecl alias "wgbox" (byval d_ip as integer, byval cstr as byte ptr, byval isel as integer) as integer
declare function dwgbut  cdecl alias "wgbut" (byval d_ip as integer, byval cstr as byte ptr, byval ival as integer) as integer
declare function dwgcmd  cdecl alias "wgcmd" (byval d_ip as integer, byval clab as byte ptr, byval cmd as byte ptr) as integer
declare function dwgdlis cdecl alias "wgdlis" (byval d_ip as integer, byval cstr as byte ptr, byval isel as integer) as integer
declare function dwgdraw cdecl alias "wgdraw" (byval d_ip as integer) as integer
declare function dwgfil  cdecl alias "wgfil" (byval d_ip as integer, byval clab as byte ptr, byval cstr as byte ptr, byval cmask as byte ptr)
declare sub dwgfin  cdecl alias "wgfin"  ( )
declare function dwgini  cdecl alias "wgini" (byval ctyp as byte ptr) as integer
declare function dwglab  cdecl alias "wglab" (byval d_ip as integer, byval cstr as byte ptr) as integer
declare function dwglis  cdecl alias "wglis" (byval d_ip as integer, byval cstr as byte ptr, byval isel as integer) as integer
declare function dwgltxt cdecl alias "wgltxt" (byval d_ip as integer, byval clab as byte ptr, byval ctext as byte ptr, byval iper as integer) as integer
declare function dwgok cdecl alias "wgok" (byval d_ip as integer) as integer
declare function dwgpbut cdecl alias "wgpbut" (byval d_ip as integer, byval clab as byte ptr) as integer
declare function dwgpop  cdecl alias "wgpop" (byval d_ip as integer, byval clab as byte ptr) as integer
declare function dwgquit cdecl alias "wgquit" (byval d_ip as integer) as integer
declare function dwgscl  cdecl alias "wgscl" (byval d_ip as integer, byval cstr as byte ptr, byval x1 as single, byval x2 as single, byval xval as single, byval ndez as integer) as integer
declare function dwgstxt cdecl alias "wgstxt" (byval d_ip as integer, byval nsize as integer, byval nmax as integer) as integer
declare function dwgtxt  cdecl alias "wgtxt" (byval d_ip as integer, byval cstr as byte ptr) as integer
declare sub dwidbar cdecl alias "widbar" (byval nzb as integer)
declare sub dwimage cdecl alias "wimage" (byval cfil as byte ptr)  
declare sub dwinapp cdecl alias "winapp" (byval copt as byte ptr)  
declare sub dwindbr cdecl alias "windbr" (byval xk as single, byval nx as integer, byval ny as integer, byval nwidth as integer, byval d_a as single)
declare sub dwinfin cdecl alias "winfin" (byval iopt as integer)
declare sub dwinfnt cdecl alias "winfnt" (byval cfont as byte ptr)
declare function dwinid  cdecl alias "winid" ( ) as integer
declare sub dwinini cdecl alias "winini" (byval p1 as any ptr, byval p2 as any ptr, byval i1 as integer, byval i2 as integer)
declare sub dwinkey cdecl alias "winkey" (byval copt as byte ptr)
declare sub dwinmod cdecl alias "winmod" (byval copt as byte ptr)
declare sub dwinopt cdecl alias "winopt" (byval iopt as integer, byval copt as byte ptr)
declare sub dwinsiz cdecl alias "winsiz" (byval nw as integer, byval nh as integer)
declare sub dwintit cdecl alias "wintit" (byval cstr as byte ptr)
declare sub dwmfmod cdecl alias "wmfmod" (byval cmod as byte ptr, byval ckey as byte ptr)
declare sub dworld  cdecl alias "world"  ( )
declare sub dwpixel cdecl alias "wpixel" (byval d_ix as integer, byval d_iy as integer, byval iclr as integer)
declare sub dwpixls cdecl alias "wpixls" (byval iray as ubyte ptr, byval d_ix as integer, byval d_iy as integer, byval nw as integer, byval nh as integer)
declare sub dwpxrow cdecl alias "wpxrow" (byval iray as ubyte ptr, byval d_ix as integer, byval d_iy as integer, byval d_n as integer)
declare function dwritfl cdecl alias "writfl" (byval nu as integer, byval cbuf as ubyte ptr, byval nbyte as integer) as integer 
declare sub dwtiff  cdecl alias "wtiff" (byval cfil as byte ptr)

'' X
declare sub dx11fnt cdecl alias "x11fnt" (byval cfont as byte ptr, byval copt as byte ptr)
declare sub dx11mod cdecl alias "x11mod" (byval copt as byte ptr)
declare function dx2dpos cdecl alias "x2dpos" (byval d_x as single, byval d_y as single) as single
declare function dx3dabs cdecl alias "x3dabs" (byval d_x as single, byval d_y as single, byval d_z as single) as single
declare function dx3dpos cdecl alias "x3dpos" (byval d_x as single, byval d_y as single, byval d_z as single) as single
declare function dx3drel cdecl alias "x3drel" (byval d_x as single, byval d_y as single, byval d_z as single) as single
declare sub dxaxgit cdecl alias "xaxgit" ( )
declare sub dxaxis  cdecl alias "xaxis"  (byval xa as single, byval xe as single, byval xorg as single, byval xstp as single, byval nl as integer, byval cstr as byte ptr, byval it as integer, byval nx as integer, byval ny as integer)
declare sub dxaxlg  cdecl alias "xaxlg"  (byval xa as single, byval xe as single, byval xorg as single, byval xstp as single, byval nl as integer, byval cstr as byte ptr, byval it as integer, byval nx as integer, byval ny as integer)
declare sub dxaxmap cdecl alias "xaxmap" (byval xa as single, byval xe as single, byval xorg as single, byval xstp as single, byval cstr as byte ptr, byval it as integer, byval ny as integer)
declare sub dxcross cdecl alias "xcross" ( )
declare sub dxdraw  cdecl alias "xdraw"  (byval d_x as single, byval d_y as single)
declare function  dxinvrs cdecl alias "xinvrs" (byval d_n as integer) as single
declare sub dxmove cdecl alias "xmove"   (byval d_x as single, byval d_y as single)
declare function  dxposn cdecl alias "xposn" (byval d_x as single) as single


'' Y
declare function dy2dpos cdecl alias "y2dpos" (byval d_x as single, byval d_y as single) as single
declare function dy3dabs cdecl alias "y3dabs" (byval d_x as single, byval d_y as single, byval d_z as single) as single
declare function dy3dpos cdecl alias "y3dpos" (byval d_x as single, byval d_y as single, byval d_z as single) as single
declare function dy3drel cdecl alias "y3drel" (byval d_x as single, byval d_y as single, byval d_z as single) as single
declare sub dyaxgit cdecl alias "yaxgit" ( )
declare sub dyaxis  cdecl alias "xaxis"  (byval ya as single, byval ye as single, byval yor as single, byval ystp as single, byval nl as integer, byval cstr as byte ptr, byval it as integer, byval nx as integer, byval ny as integer)
declare sub dyaxlg  cdecl alias "yaxlg" (byval ya as single, byval ye as single, byval yor as single, byval ystp as single, byval nl as integer, byval cstr as byte ptr, byval it as integer, byval nx as integer, byval ny as integer)
declare sub dyaxmap cdecl alias "yaxmap" (byval ya as single, byval ye as single, byval yor as single, byval ystp as single, byval cstr as byte ptr, byval it as integer, byval ny as integer)
declare sub dycross cdecl alias "ycross" ( )
declare function dyinvrs cdecl alias "yinvrs" (byval d_n as integer) as single
declare function dyposn cdecl alias "yposn" (byval d_y as single) as single

'' Z
declare function dz3dpos cdecl alias "z3dpos" (byval d_x as single, byval d_y as single, byval d_z as single) as single
declare sub dzaxis  cdecl alias "zaxis"  (byval za as single, byval ze as single, byval zor as single, byval zstp as single, byval nl as integer, byval cstr as byte ptr, byval it as integer, byval d_id as integer, byval nx as integer, byval ny as integer)
declare sub dzaxlg  cdecl alias "zaxlg"  (byval za as single, byval ze as single, byval zor as single, byval zstp as single, byval nl as integer, byval cstr as byte ptr, byval it as integer, byval d_id as integer, byval nx as integer, byval ny as integer)
declare sub dzbffin cdecl alias "zbffin" ( )
declare function dzbfini cdecl alias "zbfini" ( ) as integer
declare sub dzbflin cdecl alias "zbflin" (byval x1 as single, byval y1 as single, byval z1 as single, byval x2 as single, byval y2 as single, byval z2 as single)
declare sub dzbftri cdecl alias "zbftri" (byval d_x as single ptr, byval d_y as single ptr, byval d_z as single ptr, byval d_ic as integer ptr)
declare sub dzscale cdecl alias "zscale" (byval za as single, byval ze as single)
